## libdrumstick 0.5.0

=== CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2010 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

# The name of our project is "DRUMSTICK". CMakeLists files in this project can
# refer to the root source directory of the project as ${DRUMSTICK_SOURCE_DIR} 
# and to the root binary directory of the project as ${DRUMSTICK_BINARY_DIR}
PROJECT(DRUMSTICK)

# CMake minimum version
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

IF(CMAKE_SIZEOF_VOID_P MATCHES "8")
    SET(_INIT_LIB_SUFFIX "64")
ELSE(CMAKE_SIZEOF_VOID_P MATCHES "8")
    SET(_INIT_LIB_SUFFIX "")
ENDIF(CMAKE_SIZEOF_VOID_P MATCHES "8")
SET(LIB_SUFFIX ${_INIT_LIB_SUFFIX} CACHE STRING "optional library install directory suffix: 32, 64, none")

#Comment out if relative paths break the link scripts
#SET(CMAKE_USE_RELATIVE_PATHS OFF)

# Assorted settings
SET(CMAKE_COLOR_MAKEFILE ON)
SET(CMAKE_INCLUDE_CURRENT_DIR TRUE)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
SET(CMAKE_SKIP_RULE_DEPENDENCY FALSE)
SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# Additional CMake modules for 3rd party library checks reside here
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_admin")

# DRUMSTICK version string
SET (VERSION_MAJOR "0")
SET (VERSION_MINOR "5")
SET (VERSION_PATCH "0")
SET (VERSION_SUFFIX "")
SET (VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX})

MESSAGE(STATUS "drumstick ${VERSION} prefix: ${CMAKE_INSTALL_PREFIX}")

# User options
OPTION(STATIC_DRUMSTICK "Build static libraries instead of dynamic" OFF)
OPTION(USE_DBUS "Include DBus support (required for RealtimeKit)" ON)

MESSAGE(STATUS "Build configuration: ${CMAKE_BUILD_TYPE}")

# LIBRARY BUILD TYPE
IF(STATIC_DRUMSTICK)
    SET(BUILD_SHARED_LIBS OFF)
    add_definitions (-DDRUMSTICK_STATIC)
    MESSAGE(STATUS "Building static libraries")
ELSE(STATIC_DRUMSTICK)
    SET(BUILD_SHARED_LIBS ON)
    MESSAGE(STATUS "Building dynamic libraries")
ENDIF(STATIC_DRUMSTICK)

# Check for Qt
SET(QT_MIN_VERSION "4.4.0")
FIND_PACKAGE(Qt4 REQUIRED)
IF(QT4_FOUND)
    MESSAGE (STATUS "Found Qt4 ${QT_EDITION} version = ${QTVERSION}")
    SET (QT_USE_QTSVG TRUE)
    IF (USE_DBUS)
        SET(QT_USE_QTDBUS TRUE)
        ADD_DEFINITIONS(-DRTKIT_SUPPORT)
    ENDIF (USE_DBUS)
    INCLUDE (${QT_USE_FILE})
    INCLUDE_DIRECTORIES (${QT_INCLUDES}) 
    LINK_DIRECTORIES (${QT_LIBRARY_DIR})
    LINK_LIBRARIES (${QT_LIBRARIES})
    ADD_DEFINITIONS (-DQT_STRICT_ITERATORS)
ELSE(QT4_FOUND)
    MESSAGE(FATAL_ERROR "Qt4 not found")
ENDIF(QT4_FOUND)

# Check for PKG-CONFIG
FIND_PACKAGE(PkgConfig REQUIRED)
IF(PKG_CONFIG_FOUND)
    MESSAGE(STATUS "Program pkg-config found (${PKG_CONFIG_EXECUTABLE})")
ELSE(PKG_CONFIG_FOUND)
    MESSAGE(FATAL_ERROR "Program pkg-config not found")
ENDIF(PKG_CONFIG_FOUND)

# Initialize some variables
SET(HAVE_ALSA FALSE)

# Check for ALSA 1.0.0
PKG_CHECK_MODULES(ALSA alsa>=1.0.0)
IF(ALSA_FOUND)
    SET(HAVE_ALSA TRUE)
    ADD_DEFINITIONS(-DHAVE_ALSA)
    SET(ALSA_LIBS ${ALSA_LIBRARIES})
    LIST(APPEND ALSA_LIB_DIR ${ALSA_LIBRARY_DIRS} ${ALSA_LIBDIR})
    LIST(APPEND ALSA_INC_DIR ${ALSA_INCLUDE_DIRS} ${ALSA_INCLUDEDIR})
ELSE(ALSA_FOUND)
    MESSAGE(STATUS "Warning: ALSA library not found.")
ENDIF(ALSA_FOUND)

LINK_DIRECTORIES (
    ${DRUMSTICK_BINARY_DIR}/lib
    ${ALSA_LIB_DIR}
)

INCLUDE_DIRECTORIES ( BEFORE 
    ${DRUMSTICK_SOURCE_DIR}/library
    ${DRUMSTICK_SOURCE_DIR}/library/include
    ${ALSA_INC_DIR}
)

if (CMAKE_COMPILER_IS_GNUCXX)
# exceptions are needed by this library, please don't try to disable them!
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fexceptions -UQT_NO_EXCEPTIONS")
  if (NOT WIN32)
    include (CheckCXXCompilerFlag)
    check_cxx_compiler_flag (-fvisibility=hidden _HAVE_GCC_VISIBILITY)
    if (_HAVE_GCC_VISIBILITY)
      set (CMAKE_CXX_FLAGS 
           "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
    endif (_HAVE_GCC_VISIBILITY)
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
  endif (NOT WIN32)
endif (CMAKE_COMPILER_IS_GNUCXX)

ADD_SUBDIRECTORY(library)
ADD_SUBDIRECTORY(utils)
ADD_SUBDIRECTORY(icons)
IF(${CMAKE_SYSTEM} MATCHES "Linux")
    FIND_PACKAGE(Doxygen)
    IF(DOXYGEN_FOUND)
        CONFIGURE_FILE(
            "${CMAKE_SOURCE_DIR}/Doxyfile.in"
            "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
            IMMEDIATE @ONLY)
        ADD_CUSTOM_TARGET ( doxygen
            ${DOXYGEN} Doxyfile
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    ENDIF(DOXYGEN_FOUND)
    ADD_SUBDIRECTORY(doc)
ENDIF(${CMAKE_SYSTEM} MATCHES "Linux")

CONFIGURE_FILE(drumstick-alsa.pc.in drumstick-alsa.pc IMMEDIATE @ONLY)
CONFIGURE_FILE(drumstick-file.pc.in drumstick-file.pc IMMEDIATE @ONLY)
CONFIGURE_FILE(drumstick.spec.in drumstick.spec IMMEDIATE @ONLY)
INSTALL( FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/drumstick-file.pc
    ${CMAKE_CURRENT_BINARY_DIR}/drumstick-alsa.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig )

# XML mime types
set( SHARED_MIME_INFO_MINIMUM_VERSION "0.30" )
set( XDG_MIME_INSTALL_DIR "share/mime/packages" ) 
find_package( SharedMimeInfo )
if( SHARED_MIME_INFO_FOUND )
    install( FILES drumstick.xml DESTINATION ${XDG_MIME_INSTALL_DIR} ) 
    update_xdg_mimetypes( ${XDG_MIME_INSTALL_DIR} )     
endif( SHARED_MIME_INFO_FOUND )

# uninstall custom target
CONFIGURE_FILE(
    "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET ( uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

IF(${CMAKE_SYSTEM} MATCHES "Linux")
    # tarball target
    ADD_CUSTOM_TARGET ( tarball
        COMMAND mkdir -p drumstick-${VERSION}
        COMMAND cp -r cmake_admin drumstick-${VERSION}
        COMMAND cp -r library drumstick-${VERSION}
        COMMAND cp -r utils drumstick-${VERSION}
        COMMAND cp -r doc drumstick-${VERSION}
        COMMAND cp -r icons drumstick-${VERSION}
        COMMAND cp CMakeLists.txt AUTHORS COPYING ChangeLog INSTALL NEWS README TODO drumstick*.in drumstick.pro drumstick.xml configure* Doxyfile.in link-drumstick chkcoverage drumstick-${VERSION}
        COMMAND tar -cj --exclude=.[a-z]* -f drumstick-${VERSION}.tar.bz2 drumstick-${VERSION}
        COMMAND tar -cz --exclude=.[a-z]* -f drumstick-${VERSION}.tar.gz  drumstick-${VERSION}
        COMMAND rm -rf drumstick-${VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
ENDIF(${CMAKE_SYSTEM} MATCHES "Linux")

=== doc/CMakeLists.txt ===
# MIDI Sequencer C++ Library 
# Copyright (C) 2008-2010 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

FIND_PROGRAM(XSLTPROC_EXECUTABLE xsltproc)
IF(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    CONFIGURE_FILE(drumstick-buildsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-buildsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-drumgrid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpmid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpove.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpove.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-dumpwrk.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-metronome.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-playsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-guiplayer.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-sysinfo.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-testevents.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-testevents.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-timertest.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-timertest.xml IMMEDIATE @ONLY)
    CONFIGURE_FILE(drumstick-vpiano.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml IMMEDIATE @ONLY)
    INCLUDE(CreateManpages)
    CREATE_MANPAGES ( 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-buildsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpove.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-testevents.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-timertest.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml 
    )
ELSE(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "Warning: XSLTPROC NOT Found. Man pages won't be installed")
ENDIF(XSLTPROC_EXECUTABLE)

=== icons/CMakeLists.txt ===
INSTALL(FILES drumstick_16.png 
    DESTINATION share/icons/hicolor/16x16/apps   
    RENAME drumstick.png)

INSTALL(FILES drumstick_32.png 
    DESTINATION share/icons/hicolor/32x32/apps   
    RENAME drumstick.png)

INSTALL(FILES drumstick_48.png 
    DESTINATION share/icons/hicolor/48x48/apps   
    RENAME drumstick.png)

INSTALL(FILES drumstick_64.png 
    DESTINATION share/icons/hicolor/64x64/apps   
    RENAME drumstick.png)

INSTALL(FILES drumstick.svgz
    DESTINATION share/icons/hicolor/scalable/apps)

=== library/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2010 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

#deprecated libtool
#INCLUDE(CreateLibtoolFile)

INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_BINARY_DIR}
)

# drumstick-file library

SET(drumstick-file_QTOBJ_SRCS
    include/qsmf.h
    include/qwrk.h
    include/qove.h
)

SET(drumstick-file_HEADERS
    include/macros.h
    include/qsmf.h
    include/qwrk.h
    include/qove.h
)

SET(drumstick-file_SRCS
    src/qsmf.cpp
    src/qwrk.cpp
    src/qove.cpp
)

QT4_WRAP_CPP(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})

ADD_LIBRARY(drumstick-file
    ${drumstick-file_MOC_SRCS}
    ${drumstick-file_SRCS} 
    ${drumstick-file_HEADERS} 
)

TARGET_LINK_LIBRARIES(drumstick-file
    ${QT_LIBRARIES}
)

IF(STATIC_DRUMSTICK)
    SET_TARGET_PROPERTIES(drumstick-file PROPERTIES
        STATIC_LIB "libdrumstick-file.a"
    )
    IF(NOT WIN32)
        SET_TARGET_PROPERTIES(drumstick-file PROPERTIES
        COMPILE_FLAGS -fPIC
    )
    ENDIF(NOT WIN32)
ELSE(STATIC_DRUMSTICK)
    SET_TARGET_PROPERTIES(drumstick-file PROPERTIES
        VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
        SOVERSION ${VERSION_MAJOR}
#       OUTPUT_NAME drumstick-file-${VERSION_MAJOR}.${VERSION_MINOR}
    )
ENDIF(STATIC_DRUMSTICK)

# drumstick-alsa library
IF(ALSA_FOUND)

    SET(drumstick-alsa_QTOBJ_SRCS
        include/alsaclient.h
        include/alsaevent.h
        include/alsaport.h
        include/alsaqueue.h
        include/alsatimer.h
        include/playthread.h
    )
    
    SET(drumstick-alsa_HEADERS
        include/alsaclient.h
        include/alsaevent.h
        include/alsaport.h
        include/alsaqueue.h
        include/alsatimer.h
        include/drumstickcommon.h
        include/playthread.h
        include/subscription.h
    )
    
    SET(drumstick-alsa_SRCS
        src/alsaclient.cpp
        src/alsaevent.cpp
        src/alsaport.cpp
        src/alsaqueue.cpp
        src/alsatimer.cpp
        src/playthread.cpp
        src/subscription.cpp
    )

    QT4_WRAP_CPP(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})
   
    ADD_LIBRARY(drumstick-alsa 
        ${drumstick-alsa_MOC_SRCS}
        ${drumstick-alsa_SRCS} 
        ${drumstick-alsa_HEADERS} 
    )
    
    TARGET_LINK_LIBRARIES(drumstick-alsa
        ${QT_LIBRARIES}
        ${ALSA_LIBS}
    )
    
    IF(STATIC_DRUMSTICK)
        SET_TARGET_PROPERTIES(drumstick-alsa PROPERTIES
             STATIC_LIB "libdrumstick-alsa.a"
        )
        IF(NOT WIN32)
            SET_TARGET_PROPERTIES(drumstick-file PROPERTIES
            COMPILE_FLAGS -fPIC
        )
        ENDIF(NOT WIN32)
    ELSE(STATIC_DRUMSTICK)
        SET_TARGET_PROPERTIES(drumstick-alsa PROPERTIES
            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
            SOVERSION ${VERSION_MAJOR}
#           OUTPUT_NAME drumstick-alsa-${VERSION_MAJOR}.${VERSION_MINOR}
        )
    ENDIF(STATIC_DRUMSTICK)

#deprecated libtool 
#SET_TARGET_PROPERTIES(drumstick-alsa PROPERTIES
#    LT_DEPENDENCY_LIBS "-lasound -lQtCore"
#    LT_VERSION_CURRENT ${VERSION_MAJOR}
#    LT_VERSION_AGE ${VERSION_MINOR}
#    LT_VERSION_REVISION ${VERSION_PATCH}
#)
#CREATE_LIBTOOL_FILE(drumstick-alsa lib${LIB_SUFFIX})

    INSTALL(TARGETS drumstick-alsa 
        RUNTIME DESTINATION bin
        ARCHIVE DESTINATION lib${LIB_SUFFIX}
        LIBRARY DESTINATION lib${LIB_SUFFIX})
    INSTALL(FILES ${drumstick-alsa_HEADERS}
            DESTINATION include/drumstick)
    INSTALL(FILES include/drumstick.h
            DESTINATION include)
ENDIF(ALSA_FOUND)

INSTALL(TARGETS drumstick-file
	RUNTIME DESTINATION bin
	ARCHIVE DESTINATION lib${LIB_SUFFIX}
	LIBRARY DESTINATION lib${LIB_SUFFIX})

INSTALL(FILES ${drumstick-file_HEADERS}
        DESTINATION include/drumstick)

=== utils/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2010 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA

# common settings

INCLUDE_DIRECTORIES ( 
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/common
    ${CMAKE_CURRENT_BINARY_DIR}/common
)

FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/common/cmdversion.h
     "const QString PGM_VERSION(\"${VERSION}\");\n")

ADD_SUBDIRECTORY(common)
ADD_SUBDIRECTORY(buildsmf)
ADD_SUBDIRECTORY(dumpsmf)
ADD_SUBDIRECTORY(dumpwrk)
ADD_SUBDIRECTORY(dumpove)

IF(ALSA_FOUND)
    ADD_SUBDIRECTORY(dumpmid)
    ADD_SUBDIRECTORY(playsmf)
    ADD_SUBDIRECTORY(guiplayer)
    ADD_SUBDIRECTORY(sysinfo)
    ADD_SUBDIRECTORY(testevents)
    ADD_SUBDIRECTORY(timertest)
    ADD_SUBDIRECTORY(vpiano)
    ADD_SUBDIRECTORY(metronome)
    ADD_SUBDIRECTORY(drumgrid)
ENDIF(ALSA_FOUND)

=== utils/buildsmf/CMakeLists.txt ===
SET(buildsmf_SRCS
    buildsmf.cpp
    buildsmf.h
)

SET(buildsmf_qtobject_SRCS
    buildsmf.h
)

QT4_WRAP_CPP(buildsmf_moc_SRCS ${buildsmf_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-buildsmf 
    ${buildsmf_moc_SRCS}
    ${buildsmf_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-buildsmf
    ${QT_LIBRARIES} 
    drumstick-common
    drumstick-file
)

INSTALL(TARGETS drumstick-buildsmf 
        RUNTIME DESTINATION bin)

=== utils/common/CMakeLists.txt ===
SET ( common_SRCS
    cmdlineargs.cpp
    cmdlineargs.h
)

ADD_LIBRARY( drumstick-common STATIC
    ${common_SRCS}
)

IF(NOT WIN32)
    SET_TARGET_PROPERTIES( drumstick-common 
        PROPERTIES COMPILE_FLAGS -fPIC
	)
ENDIF(NOT WIN32)

TARGET_LINK_LIBRARIES( drumstick-common
    ${QT_LIBRARIES}
)

=== utils/drumgrid/CMakeLists.txt ===
SET(drumgrid_forms_SRCS
    drumgridabout.ui
    drumgrid.ui
)

SET(drumgrid_SRCS
    drumgridabout.cpp
    drumgridabout.h
    drumgrid.cpp
    drumgrid.h
    drumgridmodel.cpp
    drumgridmodel.h
    drumgridmain.cpp
)

SET(drumgrid_qtobject_SRCS
    drumgridabout.h
    drumgridmodel.h
    drumgrid.h
)

QT4_WRAP_UI(drumgrid_ui_SRCS ${drumgrid_forms_SRCS})

QT4_WRAP_CPP(drumgrid_moc_SRCS ${drumgrid_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-drumgrid
    ${drumgrid_ui_SRCS}
    ${drumgrid_moc_SRCS}
    ${drumgrid_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-drumgrid
    ${QT_LIBRARIES} 
    ${ALSA_LIBS} 
    drumstick-common
    drumstick-alsa
)

INSTALL(TARGETS drumstick-drumgrid 
        RUNTIME DESTINATION bin)

INSTALL(FILES drumstick-drumgrid.desktop
        DESTINATION share/applications)

=== utils/dumpmid/CMakeLists.txt ===
SET(dumpmid_SRCS
    dumpmid.cpp
    dumpmid.h
)

SET(dumpmid_qtobject_SRCS
    dumpmid.h
)

QT4_WRAP_CPP(dumpmid_moc_SRCS ${dumpmid_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-dumpmid
    ${dumpmid_moc_SRCS}
    ${dumpmid_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-dumpmid
    ${QT_LIBRARIES} 
    ${ALSA_LIBS} 
    drumstick-common
    drumstick-alsa
)

# we should install some files...
INSTALL(TARGETS drumstick-dumpmid 
        RUNTIME DESTINATION bin)

=== utils/dumpove/CMakeLists.txt ===
SET(dumpove_SRCS
    dumpove.cpp
    dumpove.h
)

SET(dumpove_qtobject_SRCS
    dumpove.h
)

QT4_WRAP_CPP(dumpove_moc_SRCS ${dumpove_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-dumpove 
    ${dumpove_moc_SRCS}
    ${dumpove_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-dumpove
    ${QT_LIBRARIES} 
    drumstick-common
    drumstick-file
)

# we should install some files...
INSTALL(TARGETS drumstick-dumpove 
        RUNTIME DESTINATION bin)

=== utils/dumpsmf/CMakeLists.txt ===
SET(dumpsmf_SRCS
    dumpsmf.cpp
    dumpsmf.h
)

SET(dumpsmf_qtobject_SRCS
    dumpsmf.h
)

QT4_WRAP_CPP(dumpsmf_moc_SRCS ${dumpsmf_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-dumpsmf 
    ${dumpsmf_moc_SRCS}
    ${dumpsmf_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-dumpsmf
    ${QT_LIBRARIES} 
    drumstick-common
    drumstick-file
)

# we should install some files...
INSTALL(TARGETS drumstick-dumpsmf 
        RUNTIME DESTINATION bin)

=== utils/dumpwrk/CMakeLists.txt ===
SET(dumpwrk_SRCS
    dumpwrk.cpp
    dumpwrk.h
)

SET(dumpwrk_qtobject_SRCS
    dumpwrk.h
)

QT4_WRAP_CPP(dumpwrk_moc_SRCS ${dumpwrk_qtobject_SRCS})

ADD_EXECUTABLE(drumstick-dumpwrk 
    ${dumpwrk_moc_SRCS}
    ${dumpwrk_SRCS}
)

TARGET_LINK_LIBRARIES(drumstick-dumpwrk
    ${QT_LIBRARIES} 
    drumstick-common
    drumstick-file
)

# we should install some files...
INSTALL(TARGETS drumstick-dumpwrk 
        RUNTIME DESTINATION bin)

=== debian/changelog ===
libdrumstick (0.5.0-3) unstable; urgency=low

  [ Adrian Knoth ]
  * Replace old binutils patch with new one:
    - The cmake maintainer suggested a different fix, so here's the new
      approach. For details, see #615742.

  [ Alessio Treglia ]
  * Build for Multi-Arch.
  * Remove missing_libs.patch, superseded by Adrian's new patch.
  * Refresh patches.
  * Bump Standards.
  * Rewrite debian/copyright to comply with DEP-5.
  * Add override to avoid Lintian's package-name-doesnt-match-sonames
    warning.
  * Include in libdrumstick-dbg only symbols coming from libdrumstick0;
    this avoids installing drumstick-tools when one needs the -DBG just
    to debug the libraries.

 -- Alessio Treglia <alessio@debian.org>  Sun, 05 Feb 2012 21:13:53 +0100

libdrumstick (0.5.0-2) unstable; urgency=low

  [ Arnout ]
  * Add Rui Fan as copyright holder to the OVE file format support.

  [ Alessio Treglia ]
  * Add patch to prevent FTBFS with newest toolchain (Closes: #615742).

 -- Alessio Treglia <alessio@debian.org>  Mon, 28 Feb 2011 12:07:20 +0100

libdrumstick (0.5.0-1) unstable; urgency=low

  [ Adrian Knoth ]
  * New upstream release.
  * Include mime-type definition file.

  [ Alessio Treglia ]
  * Add Adrian to the Uploaders list.
  * Allow DM uploads.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 09 Sep 2010 14:01:04 +0200

libdrumstick (0.4.1-1) unstable; urgency=low

  * Initial release (Closes: #579153)

 -- Arnout Engelen <arnouten@bzzt.net>  Sat, 04 Sep 2010 17:50:31 +0200

=== debian/control ===
Source: libdrumstick
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Arnout Engelen <arnouten@bzzt.net>
DM-Upload-Allowed: yes
Build-Depends:
 autotools-dev,
 cmake,
 debhelper (>= 7.0.50~),
 docbook-xsl,
 libasound2-dev,
 libqt4-dev,
 libx11-dev,
 pkg-config,
 xsltproc
Standards-Version: 3.9.2
Homepage: http://drumstick.sourceforge.net/
Vcs-Git: git://git.debian.org/pkg-multimedia/libdrumstick.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/libdrumstick.git

Package: libdrumstick-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdrumstick0 (= ${binary:Version}),
 ${misc:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer - development files
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.
 .
 This package provides the development files.

Package: libdrumstick0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.

Package: libdrumstick-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends:
 libdrumstick0 (= ${binary:Version}),
 ${misc:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer - debugging symbols
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.
 .
 This package provides the debugging symbols.

Package: drumstick-tools
Section: sound
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt4/C++ wrapper for ALSA Sequencer - utilities
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt4 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for SMF and WRK file
 processing are also included.
 .
 This package provides utilities shipped with the library:
  - drumstick-buildsmf: Standard MIDI File creation from scratch.
  - drumstick-dumpgrid: Simple Qt drum sequencer.
  - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
  - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
  - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
  - drumstick-guiplayer: Simple Qt MIDI file player.
  - drumstick-metronome: Headless MIDI metronome.
  - drumstick-playsmf: Headless MIDI file player.
  - drumstick-sysinfo: Display information about ALSA MIDI.
  - drumstick-timertest: Test performance of the ALSA timer.
  - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDFLAGS+=-Wl,--as-needed

%:
	dh $@ -S cmake

override_dh_auto_configure:
	dh_auto_configure -- -DLIBDIR=lib/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip -plibdrumstick0 --dbg-package=libdrumstick-dbg
	dh_strip --remaining-packages

=== debian/watch ===
version=3
http://sf.net/drumstick/drumstick-(.*)\.tar\.gz
